"""
**Warning: This job is a staging of the **

### Refine to Hive table hourly DAG

This DAG:
* fetches the configuration of datasets from EventStreamConfig API,
* sense for _IMPORT files generated by Gobblin in HDFS raw directories,
* spawns a Spark job to evolve the Hive table schema,
* spawns a Spark job to refine the dataset and write it to the Hive table.
* spawns a Spark job to diff the refined dataset with the legacy one.


Note: As we can't create nested dynamic tasks, we are:
* generating a single sensor with a list of files to sense
* sending a list of inputs dirs & partitions to create the Refine task

In a first deployment to production, overriding those parameters in the
Variables section of the Airflow UI is recommended. Example:
{
  "start_date": "2024-06-17T12:00:00",
  "refinery_job_jar": "hdfs:///user/myuser/TODO.jar",
  "output_database": "event_alt",
  "output_tables_base_location": "hdfs:///user/analytics/event_alt",
  "catchup": false
}
"""
import json
import logging
import re
from datetime import timedelta
from typing import Any, Dict, List, Optional

import fsspec
from airflow import DAG
from airflow.decorators import task, task_group
from delayed_timetables import DelayedHourlyTimetable

from analytics.dags.refine.refine_configuration import RefineConfiguration
from wmf_airflow_common.config.dag_properties import DagProperties
from wmf_airflow_common.operators.spark import SparkSubmitOperator
from wmf_airflow_common.sensors.hive import NamedHivePartitionsSensor
from wmf_airflow_common.sensors.url import URLSensor
from wmf_airflow_common.util import convert_dict_to_list


def _refine_scale_params_config_getter(param_name: str, default_value: str) -> Any:
    """Build a template string to get a parameter from the XCom."""
    return _config_getter("spark_refine_job_scale_params", param_name, default_value)


def _config_getter(
    config_name: str, sub_config_name: Optional[str] = None, sub_config_default: Optional[str] = None
) -> str:
    """Get a configuration from the XCom of fetch_stream_configurations."""
    subconfig_getter = ""
    if sub_config_name:
        subconfig_getter = ".get('%s', '%s')" % (sub_config_name, sub_config_default)
    return f"{{{{ ti.xcom_pull(task_ids='fetch_stream_configurations')[ti.map_index]['{config_name}']{subconfig_getter} }}}}"  # noqa: E501


def abs_path_to_file_beside_this_file(file_path: str, caller=False) -> str:
    """Return the absolute path to a file beside this file."""
    current_file_path = caller or __file__
    current_file = current_file_path.split("/")[-1]
    return current_file_path.replace(current_file, file_path)


def remove_non_alphanumeric_characters(text: str) -> str:
    """Remove non-alphanumeric characters from a string."""
    return re.sub(r"\W+", "_", text)


# Customize app names on Yarn by including the hour in the name
# e.g. refine_to_hive_hourly__refine_hive_dataset.evolve_hive_table__2024080817__2_event_eventgate_analytics_test_event
CUSTOM_YARN_TASK_NAME = (
    "{{ task_instance_key_str }}{{ data_interval_start | to_hour }}__"
    "{{ ti.map_index }}_"
    "{{ ti.xcom_pull(task_ids='fetch_stream_configurations')[ti.map_index]['stream'] |"
    "remove_non_alphanumeric_characters }}"
)


def generate_dag(
    dag_id: str,
    props: DagProperties,
    logger_name: str,
    create_easy_dag,
    hadoop_name_node: str,
) -> DAG:
    logger = logging.getLogger(logger_name)

    with create_easy_dag(
        dag_id=dag_id,
        doc_md=__doc__,
        start_date=props.start_date,
        schedule=DelayedHourlyTimetable(timedelta(hours=2)),
        tags=["hourly", "from_hive", "to_hive", "staging"],
        default_args={
            "sla": None,  # SLA are not supported for mapped tasks
            "weight_rule": "upstream",
            "execution_timeout": props.task_execution_timeout,  # replacing SLAs by timeouts.
            "retries": props.task_retries,
            "map_index_template": "{{ ti.xcom_pull(task_ids='fetch_stream_configurations')[ti.map_index]['stream'] }}",
            "skein_app_log_collection_enabled": props.skein_app_log_collection_enabled,
            # Override parallelization for this DAG to run more small jobs at once
            # Note: Some jobs use the `launchers` queue to not overload the `production`one
            "max_active_tis_per_dag": props.max_active_tis_per_dag,
        },
        catchup=props.catchup,
        max_active_tasks=props.max_active_tasks,
        max_active_runs=props.max_active_runs,
        email=props.email,
        user_defined_filters={
            "remove_non_alphanumeric_characters": remove_non_alphanumeric_characters,
        },
    ) as dag:

        @task(
            do_xcom_push=True,
            templates_dict={
                "gobblin_partition_ending": "{{data_interval_start | to_gobblin_export_path}}",
                "hive_partition_ending": "{{data_interval_start | to_hive_partition_path_hourly}}",
            },
        )
        def fetch_stream_configurations(**kwargs) -> List[Dict[str, str | Any]]:
            logger.info(f"Fetching event stream configurations from {props.event_stream_config_url}")
            with fsspec.open(props.event_stream_config_url) as f:
                configs = [
                    c
                    for c in [RefineConfiguration(config) for config in json.load(f)["streams"].values()]
                    if c.analytics_hive_ingestion_enabled
                ]
            streams_as_str = "\n  ".join(
                [f"  {config.stream}" for config in sorted(configs, key=lambda c: c.stream)]  # type: ignore
            )
            logger.info(f"{len(configs)} dataset(s) to refine:\n  {streams_as_str}")
            return [
                config.hive_dict(
                    kwargs["templates_dict"]["hive_partition_ending"],
                    kwargs["templates_dict"]["gobblin_partition_ending"],
                    database=props.output_database,
                    table_base_location=props.output_tables_base_location,
                    diff_database=props.diff_database,
                    hadoop_name_node=hadoop_name_node,
                    soft_fail_gobblin_flag_sensor=props.soft_fail_gobblin_flag_sensor,
                )
                for config in configs
            ]

        @task_group()
        def refine_hive_dataset(base_configuration: Dict[str, Any]):
            wait_for_gobblin_exports = URLSensor(
                task_id="wait_for_gobblin_export",
                url=_config_getter("hdfs_source_path_flags"),
                soft_fail=_config_getter("ignore_missing_input_paths"),
                poke_interval=60,  # 1 minute, to be reactive when the data is available.
                timeout=props.sensor_timeout,
            )

            evolve_table = SparkSubmitOperator(
                task_id="evolve_hive_table",
                name=CUSTOM_YARN_TASK_NAME,
                launcher="skein",
                master="local",
                queue="launchers",
                application_args=convert_dict_to_list(
                    {
                        "--table": _config_getter("hive_table"),
                        "--schema_uri": _config_getter("schema_uri"),
                        "--location": _config_getter("table_location"),
                        "--transform_functions": _config_getter("transform_functions"),
                        "--partition_columns": _config_getter("hive_partition_columns"),
                        "--dry_run": "false",
                    }
                ),
                java_class="org.wikimedia.analytics.refinery.job.refine.cli.EvolveHiveTable",
                application=props.refinery_job_jar,
                driver_cores=1,
                driver_memory="2G",
                # wait_for_gobblin_exports could be skipped if _IMPORTED files are not present.
                # In this case, we Refine as is.
                # none_failed_min_one_success is currently buggy: https://github.com/apache/airflow/issues/39801
                trigger_rule="none_failed",
                spark_datahub_lineage_enabled=False,  # Evolving tables don't need lineage
            )

            refine_and_diff_tasks_common_params = {
                "name": CUSTOM_YARN_TASK_NAME,
                "launcher": "skein",
                "conf": {
                    "spark.yarn.maxAppAttempts": 1,
                    "write.spark.accept-any-schema": "true",
                    # We expect some degree of parallelization between dagruns of Refine.
                    "spark.hadoop.mapreduce.fileoutputcommitter.algorithm.version": 2,
                    "spark.executor.memoryOverhead": _refine_scale_params_config_getter(
                        "spark.executor.memoryOverhead", "384MB"
                    ),
                },
                "queue": "launchers",
                "max_executors": _refine_scale_params_config_getter("max_executors", "1"),
                "master": _refine_scale_params_config_getter("master", "yarn"),
                "driver_cores": _refine_scale_params_config_getter("driver_cores", "1"),
                "driver_memory": _refine_scale_params_config_getter("driver_memory", "2G"),
                "executor_cores": _refine_scale_params_config_getter("executor_cores", "1"),
                "executor_memory": _refine_scale_params_config_getter("executor_memory", "2G"),
                "skein_memory": _refine_scale_params_config_getter("skein_memory", "None"),
                "skein_vcores": _refine_scale_params_config_getter("skein_vcores", "None"),
            }

            refine = SparkSubmitOperator(
                task_id="refine_to_hive_hourly",
                application=props.refinery_job_jar,
                java_class="org.wikimedia.analytics.refinery.job.refine.cli.RefineHiveDataset",
                application_args=convert_dict_to_list(
                    {
                        "--input_paths": _config_getter("hdfs_source_paths"),
                        "--schema_uri": _config_getter("schema_uri"),
                        "--table": _config_getter("hive_table"),
                        "--transform_functions": _config_getter("transform_functions"),
                        "--partition_paths": _config_getter("hive_partition_paths"),
                        "--spark_job_scale": _config_getter("spark_refine_job_scale"),
                        "--ignore_missing_paths": _config_getter("ignore_missing_input_paths"),
                    }
                ),
                **refine_and_diff_tasks_common_params,
                spark_datahub_lineage_enabled=False,  # Unsure if some tables are Iceberg
            )

            wait_for_legacy_refined_partition = NamedHivePartitionsSensor(
                task_id="wait_for_legacy_refine_table",
                partition_names_template=_config_getter("legacy_hive_partition_paths"),
                poke_interval=60,  # 1 minute
                timeout=props.sensor_timeout,
                soft_fail=_config_getter("ignore_missing_input_paths"),
            )

            diff_check = SparkSubmitOperator(
                task_id="diff_check",
                py_files=abs_path_to_file_beside_this_file("output_diff/output_diff.py"),
                files=",".join(
                    [
                        abs_path_to_file_beside_this_file("output_diff/output_diff.py#output_diff.py"),
                        f"{props.pyspark_extension_pkg}#gresearch",
                    ]
                ),
                application="output_diff.py",
                jars="gresearch/spark-extension_2.12-2.12.0-3.1.jar",
                application_args=convert_dict_to_list(
                    {
                        "--legacy_table": _config_getter("diff_hive_table"),
                        "--new_table": _config_getter("hive_table"),
                        "--new_table_format": "hive",
                        "--year": "{{ data_interval_start.year }}",
                        "--month": "{{ data_interval_start.month }}",
                        "--day": "{{ data_interval_start.day }}",
                        "--hour": "{{ data_interval_start.hour }}",
                        "--missing_input_paths_ignored": _config_getter("ignore_missing_input_paths"),
                    }
                ),
                # wait_for_legacy_refined_partition could be skipped if we refine as-is files are not present.
                # none_failed_min_one_success is currently buggy: https://github.com/apache/airflow/issues/39801
                trigger_rule="none_failed",
                **refine_and_diff_tasks_common_params,
                spark_datahub_lineage_enabled=False,
            )

            wait_for_gobblin_exports >> evolve_table >> refine >> wait_for_legacy_refined_partition >> diff_check

        refine_hive_dataset.expand(base_configuration=fetch_stream_configurations())

        return dag
